-- Flashing lua

local flashing = {}

local function flashPlayer(player, time)
	-- yeah
	player.flashing = time
	-- P_FlashPal doesn't work for some reason 
	-- so let's use a different way
	flashing[#player] = 10
end

addHook("ThinkFrame", function()
	for player in players.iterate do
		if flashing[#player] then
			flashing[#player] = $ - 1
		end
	end
end)

local function hudFlash(v, p, c)
	if not flashing[#p] then return end
	v.fadeScreen(0, min(10, flashing[#p]*2))
end

hud.add(hudFlash, "game")

addHook("SpecialExecute", function(activator, args)
	if not activator.mo then return end
	if not activator.mo.player then return end
	flashPlayer(activator.mo.player, args[1])
	if args[2] then flashing[#player] = 0 end
end, "FLASHTICS")