freeslot("sfx_mtstmp", "sfx_mtspen", "sfx_mtdead")

local function __Execute_Spring(mo, args)
	if not P_IsObjectOnGround(mo) then return end
	
	-- player!
	local player = mo.player
	
	-- apply pogo stuff hererer
	if player then
		player.pogoSpringJumped = 2
		player.pogoMinSpeed = 24
		player.pogoMaxSpeed = 0
	end
	-- default is.... 48!
	if not (args[1]) then
		S_StartSound(mo, sfx_mtspen)
		N_DoLegacyV1Spring(mo, 48*FRACUNIT, 0, 1)
	else
		S_StartSound(mo, sfx_mtstmp)
		N_DoLegacyV1Spring(mo, 16*FRACUNIT, 0, 1)
	end
	-- print(mo.momz)
	
	-- speed cap
	if player then
		local finalAngle = (FixedHypot(mo.momx, mo.momy) and R_PointToAngle2(0, 0, mo.momx, mo.momy) or mo.angle)
		-- In Kart code, this is BEFORE the DoPogoSpring call, but this should be fine... Execute the speedcap!
		if player.speed < 24*mapobjectscale then
			P_InstaThrust(mo, finalAngle, 24*mapobjectscale)
		end
		
		player.springstars = max(abs(mo.momz), 0) / FRACUNIT / 2
		player.springcolor = SKINCOLOR_RASPBERRY
		
		-- give them atleast a fair bit
		P_Thrust(mo, finalAngle, (24*mapobjectscale)/5)
	end
end

-- From ACS.
addHook("SpecialExecute", function(activator, args)
	if not activator.mo then return end
	__Execute_Spring(activator.mo, args)
end, "MARIOSPRING")

local ANGLE_180 = ANGLE_180

addHook("SpecialExecute", function(activator, args)
	if not activator.mo then return end
	if activator.mo.player then
		COM_BufInsertText(activator.mo.player, "resetcamera")
		activator.mo.player.drift = 0
	end
	-- P_InstaThrust(activator.mo, activator.mo.angle, FixedHypot(activator.mo.momx, activator.mo.momy))
end, "ANGLEHACK")