-- visportal doodoo
-- this tends to cause some lag so heres a cvar to disable it
local disable_echoes = CV_RegisterVar({
	name = "desert_echoes",
	defaultvalue = "Yes",
	flags = CV_NETVAR,
	PossibleValue = CV_YesNo
})

local FRACUNIT = FRACUNIT
local MF_NOGRAVITY = MF_NOGRAVITY
local MF_NOCLIP = MF_NOCLIP
local MF_NOCLIPHEIGHT = MF_NOCLIPHEIGHT
local MF_DONTENCOREMAP = MF_DONTENCOREMAP
local MT_RING = MT_RING
local MT_PLAYER = MT_PLAYER

-- objects to copy
-- no rings for now since those are a hassle AND causes a LOT of lag
local obj = {
	-- player
	MT_PLAYER, 
	-- player placed hazards pt. 1
	MT_ORBINAUT, MT_ORBINAUT_SHIELD, MT_JAWZ, MT_JAWZ_SHIELD, MT_BALLHOG, MT_LANDMINE, MT_GARDENTOP, MT_GACHABOM,
	 -- player placed hazards pt. 2
	MT_BANANA, MT_BANANA_SHIELD, MT_EGGMANITEM, MT_EGGMANITEM_SHIELD, MT_DROPTARGET, MT_DROPTARGET_SHIELD, MT_HYUDORO,
	-- item boxes
	MT_FLOATINGITEM, MT_RANDOMITEM,
	-- shrink
	-- MT_SHRINK_POHBEE, MT_SHRINK_GUN, MT_SHRINK_CHAIN, MT_SHRINK_CHAIN, MT_SHRINK_LASER, MT_SHRINK_PARTICLE, -- NO.
	-- misc
	MT_SERVANTHAND, MT_FOLLOWER,
}

-- we cant keep mooching off MT_THOK forever....
freeslot("MT_DESERTECHO")
local echoflags = (MF_NOBLOCKMAP|MF_NOGRAVITY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_DONTENCOREMAP)

mobjinfo[MT_DESERTECHO] = {
	spawnstate = S_INVISIBLE,
	flags = echoflags
}

for _, val in ipairs(obj) do
addHook("MobjThinker", function(mo)
	if not disable_echoes.value then return end
	if not mapheaderinfo[gamemap].desertechoes then return end
	if not (mo.spawnedechoes and mo.spawnedechoes[1] and mo.spawnedechoes[1].valid and mo.spawnedechoes[2] and mo.spawnedechoes[2].valid) then
		-- init echoes
		local echo1 = P_SpawnMobj(mo.x - 4096*FRACUNIT, mo.y, mo.z, MT_DESERTECHO)
		echo1.target = mo
		echo1.generaloffset = -4096*FRACUNIT
		local echo2 = P_SpawnMobj(mo.x + 4096*FRACUNIT, mo.y, mo.z, MT_DESERTECHO)
		echo2.target = mo
		echo2.generaloffset = 4096*FRACUNIT
		mo.spawnedechoes = {echo1, echo2}
	end
end, val)
end

addHook("MobjThinker", function(mo)
	if not disable_echoes.value then P_RemoveMobj(mo) return end
	
	-- target
	local target = mo.target
	-- ....doesnt exist?
	if not (target and target.valid) then P_RemoveMobj(mo) return end
	
	-- set all general states, sprites, mobj flags and render flags
	mo.state = target.state
	mo.frame = target.frame
	-- we still want this to be a general scenic mobj
	mo.flags = target.flags | echoflags
	mo.flags2 = target.flags2
	mo.eflags = target.eflags
	mo.renderflags = target.renderflags
	
	-- other properties!
	mo.color = target.color
	mo.colorized = target.colorized
	mo.angle = target.angle
	mo.scale = target.scale
	mo.destscale = target.destscale
	mo.spritexscale = target.spritexscale
	mo.spriteyscale = target.spriteyscale
	mo.spritexoffset = target.spritexoffset
	mo.spriteyoffset = target.spriteyoffset
	mo.pitch = target.pitch
	mo.roll = target.roll
	mo.rollangle = target.rollangle
	mo.extravalue1 = target.extravalue1
	mo.extravalue2 = target.extravalue2
	if target.type == MT_PLAYER then
		mo.skin = target.skin
	end
	
	-- teleport!
	P_MoveOrigin(mo, target.x + mo.generaloffset, target.y, target.z)
end, MT_DESERTECHO)
